import os
import time
from typing import Optional
from threading import Thread
from queue import SimpleQueue
import rclpy
from rclpy.executors import SingleThreadedExecutor
from rclpy.callback_groups import MutuallyExclusiveCallbackGroup
{% for d in data %}
from {{ skillset }}_managers.srv import Get{{ d.name|data_name }}Data
{%- endfor %}

{% for d in data %}
class {{ d.name|data_name }}Data:
    def __init__(self, **kwargs):
        self.__name = '{{ d.name }}'
        self.__node = rclpy.create_node(f"_{{ skillset }}_interface_{self.__name}_{os.getpid()}_{int(time.time())}", use_global_arguments=False, **kwargs)
        self.__executor = SingleThreadedExecutor()
        self.__executor.add_node(self.__node)
        self.__queue = SimpleQueue()
        self.__client = self.__node.create_client(Get{{ d.name|data_name }}Data, 
                                           f"data/get_{self.__name}",
                                           callback_group=MutuallyExclusiveCallbackGroup())
        self.__request = Get{{ d.name|data_name }}Data.Request()
        self.__thread = Thread(target=self.__spin)
        self.__thread.start()

    def __del__(self):
        self.__executor.shutdown()
        try:
            self.__thread.join()
        except RuntimeError:
            pass
        
    def destroy_node(self):
        self.__node.get_logger().debug(f"destroying node")
        self.__node.destroy_node()

    def __spin(self):
        while rclpy.ok():
            try:
                self.__executor.spin_once(timeout_sec=0.1)
            except Exception as e:
                return
    
    @property
    def name(self) -> str:
        return self.__name

    @property
    def ready(self) -> bool:
        return self.__client.service_is_ready()

    def wait_manager(self, timeout: Optional[float] = None) -> bool:
        self.__node.get_logger().debug(f"Data {self.__name} wait for manager server")
        return self.__client.wait_for_service(timeout_sec=timeout)

    def __nonzero__(self):
        return self.ready()

    def __bool__(self):
        return self.ready()

    def __done_cb(self, future):
        self.__node.get_logger().debug("data received")
        self.__queue.put(future.result().data)

    def get(self) -> Get{{ d.name|data_name }}Data.Response:
        future = self.__client.call_async(self.__request)
        future.add_done_callback(self.__done_cb)
        self.__node.get_logger().debug(f"get data {self.__name}")
        data = self.__queue.get()
        self.__node.get_logger().debug(f"-- data: {data}")
        return data
        
    def __call__(self):
        return self.get()
{% endfor %}
